//
// NewMailNotify, based on FeedParser
//
// This will refresh the alert button
//
// $Id: class_NewMailNotify.js,v 1.5 2004/10/28 02:41:38 dviner Exp $

function NewMailNotify (displayer)
{
    this.data = "";
    this.lines = new Array();
    this.displayer = displayer;
}


// parse is responsible for parsing the whole line
NewMailNotify.prototype.parse = function(fdata)
{
    var offline = false;

    var uc =
      Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    
    uc.charset = this.displayer.charset;
    
    // class_StreamListener calls parse with an empty fdata parameter
    // when the browser is offline and cannot get the yahoo feed
    // don't bother refreshing alert button
    if (fdata == "") {
        return;
    }

    //alert("Parsing!");
    this.data = fdata;
    this.lines = fdata.split("\n");
    var toolbarLine = this.lines[1];
    // now a single item in the toolbar is from CTRL-T to CTRL-U
    // so now we just find each of those...
    var ToolBarItems = toolbarLine.split('\x15');

    // now we need to find our alert button
    var i = 0;
    var numItems = ToolBarItems.length;

    for( i=0; i < numItems ; i++)
    {
        var item = uc.ConvertToUnicode(ToolBarItems[i]);
        // all items have this general layout:
        // Y! ^X <text> ^X TYPE ...
        // so first let's fetch the text
        
        var start = item.indexOf('\x18');
        start++;
        var end = item.indexOf('\x18',start);
        var text = item.substr(start,(end-start));
        
        // now find the TYPE.  this is always the first char after
        // the ^X... 
        var type = item.charAt(end+1);
        var typeTxt;
        
        // could be a button, menu, buttonmenu, editbox
        typeTxt = this.determineType(type);
        // now if this is a button, figure out which kind

        if(typeTxt == "menu")
        {
            start = end+3;
            var wholeMenu = item.substr(start);
            var menu = new Menu(text, wholeMenu);
            
            // Do we have mail? if so let's alert the user, otherwise 
            // hide the alert in case it was displayed earlier but 
            // mail has been checked
            if (menu.getType() == "alert")
            {
                if (menu.items.length > 0) {
                    var alertPopup = this.displayer.buildMenuPopup(menu.getItems());
                    
                    document.getElementById(this.displayer.AlertButtonId).style.display = "";
                    
                    var AlertButtonMenu = document.getElementById(this.displayer.AlertButtonId);

                    // Replace the alert menu item
                    try {
                        // Try to replace the existing one
                        AlertButtonMenu.replaceChild(alertPopup,
                                                AlertButtonMenu.childNodes[0]);
                    } catch (e) {
                        // Didn't work...
                        try {
                            // Add a new button
                            AlertButtonMenu.childNodes[0].appendChild(alertPopup.childNodes[0]);
                        } catch (e) {
                            // Error refreshing alert button
                        }                       
                    }
                    
                } else {
                    document.getElementById(this.displayer.AlertButtonId).style.display = "none";
                }
            } 
        }
    }
    delete this.displayer;
}

// determineType takes a character, and returns a string
// that represents what the item is supposed to be in the toolbar.
// ^B is a button
// ^C is a menu
// ^D is a button and a menu
NewMailNotify.prototype.determineType = function(txt)
{
    var code = txt.charCodeAt(0);
    switch(code)
    {
        case 2:
        {
            return "button";
        }
        case 3:
        {
            return "menu";
        }
        case 4:
        {
            return "buttonmenu";
        }
        case 7:
        {
            return "editbox";
        }
        case 131:
        {
            return "messenger";
        }
        default:
        {
            return "unknown";
        }
    }
}
